package cn.iocoder.yudao.module.mes.service.moldget;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.mes.controller.admin.moldget.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.moldget.MoldGetDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.mes.dal.mysql.moldget.MoldGetMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.*;

/**
 * 模具管理-领模申请 Service 实现类
 *
 * @author 内蒙必硕
 */
@Service
@Validated
public class MoldGetServiceImpl implements MoldGetService {

    @Resource
    private MoldGetMapper moldGetMapper;

    @Override
    public Long createMoldGet(MoldGetSaveReqVO createReqVO) {
        // 插入
        MoldGetDO moldGet = BeanUtils.toBean(createReqVO, MoldGetDO.class);
        moldGetMapper.insert(moldGet);
        // 返回
        return moldGet.getId();
    }

    @Override
    public void updateMoldGet(MoldGetSaveReqVO updateReqVO) {
        // 校验存在
        validateMoldGetExists(updateReqVO.getId());
        // 更新
        MoldGetDO updateObj = BeanUtils.toBean(updateReqVO, MoldGetDO.class);
        moldGetMapper.updateById(updateObj);
    }

    @Override
    public void deleteMoldGet(Long id) {
        // 校验存在
        validateMoldGetExists(id);
        // 删除
        moldGetMapper.deleteById(id);
    }

    private void validateMoldGetExists(Long id) {
        if (moldGetMapper.selectById(id) == null) {
            throw exception(MOLD_GET_NOT_EXISTS);
        }
    }

    @Override
    public MoldGetDO getMoldGet(Long id) {
        return moldGetMapper.selectById(id);
    }

    @Override
    public PageResult<MoldGetDO> getMoldGetPage(MoldGetPageReqVO pageReqVO) {
        return moldGetMapper.selectPage(pageReqVO);
    }

}